# Copyright 2019 the V8 project authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can
# be found in the LICENSE file.

# This file is automatically generated by mkgrokdump and should not
# be modified manually.

# List of known V8 instance types.
# yapf: disable

INSTANCE_TYPES = {
  0: "INTERNALIZED_STRING_TYPE",
  2: "EXTERNAL_INTERNALIZED_STRING_TYPE",
  8: "ONE_BYTE_INTERNALIZED_STRING_TYPE",
  10: "EXTERNAL_ONE_BYTE_INTERNALIZED_STRING_TYPE",
  18: "UNCACHED_EXTERNAL_INTERNALIZED_STRING_TYPE",
  26: "UNCACHED_EXTERNAL_ONE_BYTE_INTERNALIZED_STRING_TYPE",
  32: "STRING_TYPE",
  33: "CONS_STRING_TYPE",
  34: "EXTERNAL_STRING_TYPE",
  35: "SLICED_STRING_TYPE",
  37: "THIN_STRING_TYPE",
  40: "ONE_BYTE_STRING_TYPE",
  41: "CONS_ONE_BYTE_STRING_TYPE",
  42: "EXTERNAL_ONE_BYTE_STRING_TYPE",
  43: "SLICED_ONE_BYTE_STRING_TYPE",
  45: "THIN_ONE_BYTE_STRING_TYPE",
  50: "UNCACHED_EXTERNAL_STRING_TYPE",
  58: "UNCACHED_EXTERNAL_ONE_BYTE_STRING_TYPE",
  96: "SHARED_STRING_TYPE",
  101: "SHARED_THIN_STRING_TYPE",
  104: "SHARED_ONE_BYTE_STRING_TYPE",
  109: "SHARED_THIN_ONE_BYTE_STRING_TYPE",
  128: "SYMBOL_TYPE",
  129: "BIG_INT_BASE_TYPE",
  130: "HEAP_NUMBER_TYPE",
  131: "ODDBALL_TYPE",
  132: "PROMISE_FULFILL_REACTION_JOB_TASK_TYPE",
  133: "PROMISE_REJECT_REACTION_JOB_TASK_TYPE",
  134: "CALLABLE_TASK_TYPE",
  135: "CALLBACK_TASK_TYPE",
  136: "PROMISE_RESOLVE_THENABLE_JOB_TASK_TYPE",
  137: "LOAD_HANDLER_TYPE",
  138: "STORE_HANDLER_TYPE",
  139: "FUNCTION_TEMPLATE_INFO_TYPE",
  140: "OBJECT_TEMPLATE_INFO_TYPE",
  141: "ACCESS_CHECK_INFO_TYPE",
  142: "ACCESSOR_INFO_TYPE",
  143: "ACCESSOR_PAIR_TYPE",
  144: "ALIASED_ARGUMENTS_ENTRY_TYPE",
  145: "ALLOCATION_MEMENTO_TYPE",
  146: "ALLOCATION_SITE_TYPE",
  147: "ARRAY_BOILERPLATE_DESCRIPTION_TYPE",
  148: "ASM_WASM_DATA_TYPE",
  149: "ASYNC_GENERATOR_REQUEST_TYPE",
  150: "BREAK_POINT_TYPE",
  151: "BREAK_POINT_INFO_TYPE",
  152: "CACHED_TEMPLATE_OBJECT_TYPE",
  153: "CALL_HANDLER_INFO_TYPE",
  154: "CALL_SITE_INFO_TYPE",
  155: "CLASS_POSITIONS_TYPE",
  156: "DEBUG_INFO_TYPE",
  157: "ENUM_CACHE_TYPE",
  158: "ERROR_STACK_DATA_TYPE",
  159: "FEEDBACK_CELL_TYPE",
  160: "FUNCTION_TEMPLATE_RARE_DATA_TYPE",
  161: "INTERCEPTOR_INFO_TYPE",
  162: "INTERPRETER_DATA_TYPE",
  163: "MODULE_REQUEST_TYPE",
  164: "PROMISE_CAPABILITY_TYPE",
  165: "PROMISE_REACTION_TYPE",
  166: "PROPERTY_DESCRIPTOR_OBJECT_TYPE",
  167: "PROTOTYPE_INFO_TYPE",
  168: "REG_EXP_BOILERPLATE_DESCRIPTION_TYPE",
  169: "SCRIPT_TYPE",
  170: "SCRIPT_OR_MODULE_TYPE",
  171: "SOURCE_TEXT_MODULE_INFO_ENTRY_TYPE",
  172: "STACK_FRAME_INFO_TYPE",
  173: "TEMPLATE_OBJECT_DESCRIPTION_TYPE",
  174: "TUPLE2_TYPE",
  175: "WASM_CONTINUATION_OBJECT_TYPE",
  176: "WASM_EXCEPTION_TAG_TYPE",
  177: "WASM_INDIRECT_FUNCTION_TABLE_TYPE",
  178: "FIXED_ARRAY_TYPE",
  179: "HASH_TABLE_TYPE",
  180: "EPHEMERON_HASH_TABLE_TYPE",
  181: "GLOBAL_DICTIONARY_TYPE",
  182: "NAME_DICTIONARY_TYPE",
  183: "NAME_TO_INDEX_HASH_TABLE_TYPE",
  184: "NUMBER_DICTIONARY_TYPE",
  185: "ORDERED_HASH_MAP_TYPE",
  186: "ORDERED_HASH_SET_TYPE",
  187: "ORDERED_NAME_DICTIONARY_TYPE",
  188: "REGISTERED_SYMBOL_TABLE_TYPE",
  189: "SIMPLE_NUMBER_DICTIONARY_TYPE",
  190: "CLOSURE_FEEDBACK_CELL_ARRAY_TYPE",
  191: "OBJECT_BOILERPLATE_DESCRIPTION_TYPE",
  192: "SCRIPT_CONTEXT_TABLE_TYPE",
  193: "BYTE_ARRAY_TYPE",
  194: "BYTECODE_ARRAY_TYPE",
  195: "FIXED_DOUBLE_ARRAY_TYPE",
  196: "INTERNAL_CLASS_WITH_SMI_ELEMENTS_TYPE",
  197: "SLOPPY_ARGUMENTS_ELEMENTS_TYPE",
  198: "TURBOFAN_BITSET_TYPE_TYPE",
  199: "TURBOFAN_HEAP_CONSTANT_TYPE_TYPE",
  200: "TURBOFAN_OTHER_NUMBER_CONSTANT_TYPE_TYPE",
  201: "TURBOFAN_RANGE_TYPE_TYPE",
  202: "TURBOFAN_UNION_TYPE_TYPE",
  203: "CELL_TYPE",
  204: "FOREIGN_TYPE",
  205: "WASM_INTERNAL_FUNCTION_TYPE",
  206: "WASM_TYPE_INFO_TYPE",
  207: "AWAIT_CONTEXT_TYPE",
  208: "BLOCK_CONTEXT_TYPE",
  209: "CATCH_CONTEXT_TYPE",
  210: "DEBUG_EVALUATE_CONTEXT_TYPE",
  211: "EVAL_CONTEXT_TYPE",
  212: "FUNCTION_CONTEXT_TYPE",
  213: "MODULE_CONTEXT_TYPE",
  214: "NATIVE_CONTEXT_TYPE",
  215: "SCRIPT_CONTEXT_TYPE",
  216: "WITH_CONTEXT_TYPE",
  217: "UNCOMPILED_DATA_WITH_PREPARSE_DATA_TYPE",
  218: "UNCOMPILED_DATA_WITH_PREPARSE_DATA_AND_JOB_TYPE",
  219: "UNCOMPILED_DATA_WITHOUT_PREPARSE_DATA_TYPE",
  220: "UNCOMPILED_DATA_WITHOUT_PREPARSE_DATA_WITH_JOB_TYPE",
  221: "WASM_FUNCTION_DATA_TYPE",
  222: "WASM_CAPI_FUNCTION_DATA_TYPE",
  223: "WASM_EXPORTED_FUNCTION_DATA_TYPE",
  224: "WASM_JS_FUNCTION_DATA_TYPE",
  225: "EXPORTED_SUB_CLASS_BASE_TYPE",
  226: "EXPORTED_SUB_CLASS_TYPE",
  227: "EXPORTED_SUB_CLASS2_TYPE",
  228: "SMALL_ORDERED_HASH_MAP_TYPE",
  229: "SMALL_ORDERED_HASH_SET_TYPE",
  230: "SMALL_ORDERED_NAME_DICTIONARY_TYPE",
  231: "ABSTRACT_INTERNAL_CLASS_SUBCLASS1_TYPE",
  232: "ABSTRACT_INTERNAL_CLASS_SUBCLASS2_TYPE",
  233: "DESCRIPTOR_ARRAY_TYPE",
  234: "STRONG_DESCRIPTOR_ARRAY_TYPE",
  235: "SOURCE_TEXT_MODULE_TYPE",
  236: "SYNTHETIC_MODULE_TYPE",
  237: "WEAK_FIXED_ARRAY_TYPE",
  238: "TRANSITION_ARRAY_TYPE",
  239: "CODE_TYPE",
  240: "CODE_DATA_CONTAINER_TYPE",
  241: "COVERAGE_INFO_TYPE",
  242: "EMBEDDER_DATA_ARRAY_TYPE",
  243: "FEEDBACK_METADATA_TYPE",
  244: "FEEDBACK_VECTOR_TYPE",
  245: "FILLER_TYPE",
  246: "FREE_SPACE_TYPE",
  247: "INTERNAL_CLASS_TYPE",
  248: "INTERNAL_CLASS_WITH_STRUCT_ELEMENTS_TYPE",
  249: "MAP_TYPE",
  250: "MEGA_DOM_HANDLER_TYPE",
  251: "ON_HEAP_BASIC_BLOCK_PROFILER_DATA_TYPE",
  252: "PREPARSE_DATA_TYPE",
  253: "PROPERTY_ARRAY_TYPE",
  254: "PROPERTY_CELL_TYPE",
  255: "SCOPE_INFO_TYPE",
  256: "SHARED_FUNCTION_INFO_TYPE",
  257: "SMI_BOX_TYPE",
  258: "SMI_PAIR_TYPE",
  259: "SORT_STATE_TYPE",
  260: "SWISS_NAME_DICTIONARY_TYPE",
  261: "WASM_API_FUNCTION_REF_TYPE",
  262: "WASM_ON_FULFILLED_DATA_TYPE",
  263: "WEAK_ARRAY_LIST_TYPE",
  264: "WEAK_CELL_TYPE",
  265: "WASM_ARRAY_TYPE",
  266: "WASM_STRUCT_TYPE",
  267: "JS_PROXY_TYPE",
  1057: "JS_OBJECT_TYPE",
  268: "JS_GLOBAL_OBJECT_TYPE",
  269: "JS_GLOBAL_PROXY_TYPE",
  270: "JS_MODULE_NAMESPACE_TYPE",
  1040: "JS_SPECIAL_API_OBJECT_TYPE",
  1041: "JS_PRIMITIVE_WRAPPER_TYPE",
  1058: "JS_API_OBJECT_TYPE",
  2058: "JS_LAST_DUMMY_API_OBJECT_TYPE",
  2059: "JS_BOUND_FUNCTION_TYPE",
  2060: "JS_WRAPPED_FUNCTION_TYPE",
  2061: "JS_FUNCTION_TYPE",
  2062: "BIGINT64_TYPED_ARRAY_CONSTRUCTOR_TYPE",
  2063: "BIGUINT64_TYPED_ARRAY_CONSTRUCTOR_TYPE",
  2064: "FLOAT32_TYPED_ARRAY_CONSTRUCTOR_TYPE",
  2065: "FLOAT64_TYPED_ARRAY_CONSTRUCTOR_TYPE",
  2066: "INT16_TYPED_ARRAY_CONSTRUCTOR_TYPE",
  2067: "INT32_TYPED_ARRAY_CONSTRUCTOR_TYPE",
  2068: "INT8_TYPED_ARRAY_CONSTRUCTOR_TYPE",
  2069: "UINT16_TYPED_ARRAY_CONSTRUCTOR_TYPE",
  2070: "UINT32_TYPED_ARRAY_CONSTRUCTOR_TYPE",
  2071: "UINT8_CLAMPED_TYPED_ARRAY_CONSTRUCTOR_TYPE",
  2072: "UINT8_TYPED_ARRAY_CONSTRUCTOR_TYPE",
  2073: "JS_ARRAY_CONSTRUCTOR_TYPE",
  2074: "JS_PROMISE_CONSTRUCTOR_TYPE",
  2075: "JS_REG_EXP_CONSTRUCTOR_TYPE",
  2076: "JS_CLASS_CONSTRUCTOR_TYPE",
  2077: "JS_ARRAY_ITERATOR_PROTOTYPE_TYPE",
  2078: "JS_ITERATOR_PROTOTYPE_TYPE",
  2079: "JS_MAP_ITERATOR_PROTOTYPE_TYPE",
  2080: "JS_OBJECT_PROTOTYPE_TYPE",
  2081: "JS_PROMISE_PROTOTYPE_TYPE",
  2082: "JS_REG_EXP_PROTOTYPE_TYPE",
  2083: "JS_SET_ITERATOR_PROTOTYPE_TYPE",
  2084: "JS_SET_PROTOTYPE_TYPE",
  2085: "JS_STRING_ITERATOR_PROTOTYPE_TYPE",
  2086: "JS_TYPED_ARRAY_PROTOTYPE_TYPE",
  2087: "JS_MAP_KEY_ITERATOR_TYPE",
  2088: "JS_MAP_KEY_VALUE_ITERATOR_TYPE",
  2089: "JS_MAP_VALUE_ITERATOR_TYPE",
  2090: "JS_SET_KEY_VALUE_ITERATOR_TYPE",
  2091: "JS_SET_VALUE_ITERATOR_TYPE",
  2092: "JS_GENERATOR_OBJECT_TYPE",
  2093: "JS_ASYNC_FUNCTION_OBJECT_TYPE",
  2094: "JS_ASYNC_GENERATOR_OBJECT_TYPE",
  2095: "JS_DATA_VIEW_TYPE",
  2096: "JS_TYPED_ARRAY_TYPE",
  2097: "JS_MAP_TYPE",
  2098: "JS_SET_TYPE",
  2099: "JS_WEAK_MAP_TYPE",
  2100: "JS_WEAK_SET_TYPE",
  2101: "JS_ARGUMENTS_OBJECT_TYPE",
  2102: "JS_ARRAY_TYPE",
  2103: "JS_ARRAY_BUFFER_TYPE",
  2104: "JS_ARRAY_ITERATOR_TYPE",
  2105: "JS_ASYNC_FROM_SYNC_ITERATOR_TYPE",
  2106: "JS_COLLATOR_TYPE",
  2107: "JS_CONTEXT_EXTENSION_OBJECT_TYPE",
  2108: "JS_DATE_TYPE",
  2109: "JS_DATE_TIME_FORMAT_TYPE",
  2110: "JS_DISPLAY_NAMES_TYPE",
  2111: "JS_ERROR_TYPE",
  2112: "JS_EXTERNAL_OBJECT_TYPE",
  2113: "JS_FINALIZATION_REGISTRY_TYPE",
  2114: "JS_LIST_FORMAT_TYPE",
  2115: "JS_LOCALE_TYPE",
  2116: "JS_MESSAGE_OBJECT_TYPE",
  2117: "JS_NUMBER_FORMAT_TYPE",
  2118: "JS_PLURAL_RULES_TYPE",
  2119: "JS_PROMISE_TYPE",
  2120: "JS_REG_EXP_TYPE",
  2121: "JS_REG_EXP_STRING_ITERATOR_TYPE",
  2122: "JS_RELATIVE_TIME_FORMAT_TYPE",
  2123: "JS_SEGMENT_ITERATOR_TYPE",
  2124: "JS_SEGMENTER_TYPE",
  2125: "JS_SEGMENTS_TYPE",
  2126: "JS_SHADOW_REALM_TYPE",
  2127: "JS_SHARED_STRUCT_TYPE",
  2128: "JS_STRING_ITERATOR_TYPE",
  2129: "JS_TEMPORAL_CALENDAR_TYPE",
  2130: "JS_TEMPORAL_DURATION_TYPE",
  2131: "JS_TEMPORAL_INSTANT_TYPE",
  2132: "JS_TEMPORAL_PLAIN_DATE_TYPE",
  2133: "JS_TEMPORAL_PLAIN_DATE_TIME_TYPE",
  2134: "JS_TEMPORAL_PLAIN_MONTH_DAY_TYPE",
  2135: "JS_TEMPORAL_PLAIN_TIME_TYPE",
  2136: "JS_TEMPORAL_PLAIN_YEAR_MONTH_TYPE",
  2137: "JS_TEMPORAL_TIME_ZONE_TYPE",
  2138: "JS_TEMPORAL_ZONED_DATE_TIME_TYPE",
  2139: "JS_V8_BREAK_ITERATOR_TYPE",
  2140: "JS_WEAK_REF_TYPE",
  2141: "WASM_GLOBAL_OBJECT_TYPE",
  2142: "WASM_INSTANCE_OBJECT_TYPE",
  2143: "WASM_MEMORY_OBJECT_TYPE",
  2144: "WASM_MODULE_OBJECT_TYPE",
  2145: "WASM_SUSPENDER_OBJECT_TYPE",
  2146: "WASM_TABLE_OBJECT_TYPE",
  2147: "WASM_TAG_OBJECT_TYPE",
  2148: "WASM_VALUE_OBJECT_TYPE",
}

# List of known V8 maps.
KNOWN_MAPS = {
    ("read_only_space", 0x02151): (249, "MetaMap"),
    ("read_only_space", 0x02179): (131, "NullMap"),
    ("read_only_space", 0x021a1): (234, "StrongDescriptorArrayMap"),
    ("read_only_space", 0x021c9): (263, "WeakArrayListMap"),
    ("read_only_space", 0x0220d): (157, "EnumCacheMap"),
    ("read_only_space", 0x02241): (178, "FixedArrayMap"),
    ("read_only_space", 0x0228d): (8, "OneByteInternalizedStringMap"),
    ("read_only_space", 0x022d9): (246, "FreeSpaceMap"),
    ("read_only_space", 0x02301): (245, "OnePointerFillerMap"),
    ("read_only_space", 0x02329): (245, "TwoPointerFillerMap"),
    ("read_only_space", 0x02351): (131, "UninitializedMap"),
    ("read_only_space", 0x023c9): (131, "UndefinedMap"),
    ("read_only_space", 0x0240d): (130, "HeapNumberMap"),
    ("read_only_space", 0x02441): (131, "TheHoleMap"),
    ("read_only_space", 0x024a1): (131, "BooleanMap"),
    ("read_only_space", 0x02545): (193, "ByteArrayMap"),
    ("read_only_space", 0x0256d): (178, "FixedCOWArrayMap"),
    ("read_only_space", 0x02595): (179, "HashTableMap"),
    ("read_only_space", 0x025bd): (128, "SymbolMap"),
    ("read_only_space", 0x025e5): (40, "OneByteStringMap"),
    ("read_only_space", 0x0260d): (255, "ScopeInfoMap"),
    ("read_only_space", 0x02635): (256, "SharedFunctionInfoMap"),
    ("read_only_space", 0x0265d): (239, "CodeMap"),
    ("read_only_space", 0x02685): (203, "CellMap"),
    ("read_only_space", 0x026ad): (254, "GlobalPropertyCellMap"),
    ("read_only_space", 0x026d5): (204, "ForeignMap"),
    ("read_only_space", 0x026fd): (238, "TransitionArrayMap"),
    ("read_only_space", 0x02725): (45, "ThinOneByteStringMap"),
    ("read_only_space", 0x0274d): (244, "FeedbackVectorMap"),
    ("read_only_space", 0x02785): (131, "ArgumentsMarkerMap"),
    ("read_only_space", 0x027e5): (131, "ExceptionMap"),
    ("read_only_space", 0x02841): (131, "TerminationExceptionMap"),
    ("read_only_space", 0x028a9): (131, "OptimizedOutMap"),
    ("read_only_space", 0x02909): (131, "StaleRegisterMap"),
    ("read_only_space", 0x02969): (192, "ScriptContextTableMap"),
    ("read_only_space", 0x02991): (190, "ClosureFeedbackCellArrayMap"),
    ("read_only_space", 0x029b9): (243, "FeedbackMetadataArrayMap"),
    ("read_only_space", 0x029e1): (178, "ArrayListMap"),
    ("read_only_space", 0x02a09): (129, "BigIntMap"),
    ("read_only_space", 0x02a31): (191, "ObjectBoilerplateDescriptionMap"),
    ("read_only_space", 0x02a59): (194, "BytecodeArrayMap"),
    ("read_only_space", 0x02a81): (240, "CodeDataContainerMap"),
    ("read_only_space", 0x02aa9): (241, "CoverageInfoMap"),
    ("read_only_space", 0x02ad1): (195, "FixedDoubleArrayMap"),
    ("read_only_space", 0x02af9): (181, "GlobalDictionaryMap"),
    ("read_only_space", 0x02b21): (159, "ManyClosuresCellMap"),
    ("read_only_space", 0x02b49): (250, "MegaDomHandlerMap"),
    ("read_only_space", 0x02b71): (178, "ModuleInfoMap"),
    ("read_only_space", 0x02b99): (182, "NameDictionaryMap"),
    ("read_only_space", 0x02bc1): (159, "NoClosuresCellMap"),
    ("read_only_space", 0x02be9): (184, "NumberDictionaryMap"),
    ("read_only_space", 0x02c11): (159, "OneClosureCellMap"),
    ("read_only_space", 0x02c39): (185, "OrderedHashMapMap"),
    ("read_only_space", 0x02c61): (186, "OrderedHashSetMap"),
    ("read_only_space", 0x02c89): (183, "NameToIndexHashTableMap"),
    ("read_only_space", 0x02cb1): (188, "RegisteredSymbolTableMap"),
    ("read_only_space", 0x02cd9): (187, "OrderedNameDictionaryMap"),
    ("read_only_space", 0x02d01): (252, "PreparseDataMap"),
    ("read_only_space", 0x02d29): (253, "PropertyArrayMap"),
    ("read_only_space", 0x02d51): (153, "SideEffectCallHandlerInfoMap"),
    ("read_only_space", 0x02d79): (153, "SideEffectFreeCallHandlerInfoMap"),
    ("read_only_space", 0x02da1): (153, "NextCallSideEffectFreeCallHandlerInfoMap"),
    ("read_only_space", 0x02dc9): (189, "SimpleNumberDictionaryMap"),
    ("read_only_space", 0x02df1): (228, "SmallOrderedHashMapMap"),
    ("read_only_space", 0x02e19): (229, "SmallOrderedHashSetMap"),
    ("read_only_space", 0x02e41): (230, "SmallOrderedNameDictionaryMap"),
    ("read_only_space", 0x02e69): (235, "SourceTextModuleMap"),
    ("read_only_space", 0x02e91): (260, "SwissNameDictionaryMap"),
    ("read_only_space", 0x02eb9): (236, "SyntheticModuleMap"),
    ("read_only_space", 0x02ee1): (261, "WasmApiFunctionRefMap"),
    ("read_only_space", 0x02f09): (222, "WasmCapiFunctionDataMap"),
    ("read_only_space", 0x02f31): (223, "WasmExportedFunctionDataMap"),
    ("read_only_space", 0x02f59): (205, "WasmInternalFunctionMap"),
    ("read_only_space", 0x02f81): (224, "WasmJSFunctionDataMap"),
    ("read_only_space", 0x02fa9): (262, "WasmOnFulfilledDataMap"),
    ("read_only_space", 0x02fd1): (206, "WasmTypeInfoMap"),
    ("read_only_space", 0x02ff9): (237, "WeakFixedArrayMap"),
    ("read_only_space", 0x03021): (180, "EphemeronHashTableMap"),
    ("read_only_space", 0x03049): (242, "EmbedderDataArrayMap"),
    ("read_only_space", 0x03071): (264, "WeakCellMap"),
    ("read_only_space", 0x03099): (32, "StringMap"),
    ("read_only_space", 0x030c1): (41, "ConsOneByteStringMap"),
    ("read_only_space", 0x030e9): (33, "ConsStringMap"),
    ("read_only_space", 0x03111): (37, "ThinStringMap"),
    ("read_only_space", 0x03139): (35, "SlicedStringMap"),
    ("read_only_space", 0x03161): (43, "SlicedOneByteStringMap"),
    ("read_only_space", 0x03189): (34, "ExternalStringMap"),
    ("read_only_space", 0x031b1): (42, "ExternalOneByteStringMap"),
    ("read_only_space", 0x031d9): (50, "UncachedExternalStringMap"),
    ("read_only_space", 0x03201): (0, "InternalizedStringMap"),
    ("read_only_space", 0x03229): (2, "ExternalInternalizedStringMap"),
    ("read_only_space", 0x03251): (10, "ExternalOneByteInternalizedStringMap"),
    ("read_only_space", 0x03279): (18, "UncachedExternalInternalizedStringMap"),
    ("read_only_space", 0x032a1): (26, "UncachedExternalOneByteInternalizedStringMap"),
    ("read_only_space", 0x032c9): (58, "UncachedExternalOneByteStringMap"),
    ("read_only_space", 0x032f1): (104, "SharedOneByteStringMap"),
    ("read_only_space", 0x03319): (96, "SharedStringMap"),
    ("read_only_space", 0x03341): (109, "SharedThinOneByteStringMap"),
    ("read_only_space", 0x03369): (101, "SharedThinStringMap"),
    ("read_only_space", 0x03391): (96, "TwoByteSeqStringMigrationSentinelMap"),
    ("read_only_space", 0x033b9): (104, "OneByteSeqStringMigrationSentinelMap"),
    ("read_only_space", 0x033e1): (131, "SelfReferenceMarkerMap"),
    ("read_only_space", 0x03409): (131, "BasicBlockCountersMarkerMap"),
    ("read_only_space", 0x0344d): (147, "ArrayBoilerplateDescriptionMap"),
    ("read_only_space", 0x0354d): (161, "InterceptorInfoMap"),
    ("read_only_space", 0x0601d): (132, "PromiseFulfillReactionJobTaskMap"),
    ("read_only_space", 0x06045): (133, "PromiseRejectReactionJobTaskMap"),
    ("read_only_space", 0x0606d): (134, "CallableTaskMap"),
    ("read_only_space", 0x06095): (135, "CallbackTaskMap"),
    ("read_only_space", 0x060bd): (136, "PromiseResolveThenableJobTaskMap"),
    ("read_only_space", 0x060e5): (139, "FunctionTemplateInfoMap"),
    ("read_only_space", 0x0610d): (140, "ObjectTemplateInfoMap"),
    ("read_only_space", 0x06135): (141, "AccessCheckInfoMap"),
    ("read_only_space", 0x0615d): (142, "AccessorInfoMap"),
    ("read_only_space", 0x06185): (143, "AccessorPairMap"),
    ("read_only_space", 0x061ad): (144, "AliasedArgumentsEntryMap"),
    ("read_only_space", 0x061d5): (145, "AllocationMementoMap"),
    ("read_only_space", 0x061fd): (148, "AsmWasmDataMap"),
    ("read_only_space", 0x06225): (149, "AsyncGeneratorRequestMap"),
    ("read_only_space", 0x0624d): (150, "BreakPointMap"),
    ("read_only_space", 0x06275): (151, "BreakPointInfoMap"),
    ("read_only_space", 0x0629d): (152, "CachedTemplateObjectMap"),
    ("read_only_space", 0x062c5): (154, "CallSiteInfoMap"),
    ("read_only_space", 0x062ed): (155, "ClassPositionsMap"),
    ("read_only_space", 0x06315): (156, "DebugInfoMap"),
    ("read_only_space", 0x0633d): (158, "ErrorStackDataMap"),
    ("read_only_space", 0x06365): (160, "FunctionTemplateRareDataMap"),
    ("read_only_space", 0x0638d): (162, "InterpreterDataMap"),
    ("read_only_space", 0x063b5): (163, "ModuleRequestMap"),
    ("read_only_space", 0x063dd): (164, "PromiseCapabilityMap"),
    ("read_only_space", 0x06405): (165, "PromiseReactionMap"),
    ("read_only_space", 0x0642d): (166, "PropertyDescriptorObjectMap"),
    ("read_only_space", 0x06455): (167, "PrototypeInfoMap"),
    ("read_only_space", 0x0647d): (168, "RegExpBoilerplateDescriptionMap"),
    ("read_only_space", 0x064a5): (169, "ScriptMap"),
    ("read_only_space", 0x064cd): (170, "ScriptOrModuleMap"),
    ("read_only_space", 0x064f5): (171, "SourceTextModuleInfoEntryMap"),
    ("read_only_space", 0x0651d): (172, "StackFrameInfoMap"),
    ("read_only_space", 0x06545): (173, "TemplateObjectDescriptionMap"),
    ("read_only_space", 0x0656d): (174, "Tuple2Map"),
    ("read_only_space", 0x06595): (175, "WasmContinuationObjectMap"),
    ("read_only_space", 0x065bd): (176, "WasmExceptionTagMap"),
    ("read_only_space", 0x065e5): (177, "WasmIndirectFunctionTableMap"),
    ("read_only_space", 0x0660d): (197, "SloppyArgumentsElementsMap"),
    ("read_only_space", 0x06635): (233, "DescriptorArrayMap"),
    ("read_only_space", 0x0665d): (219, "UncompiledDataWithoutPreparseDataMap"),
    ("read_only_space", 0x06685): (217, "UncompiledDataWithPreparseDataMap"),
    ("read_only_space", 0x066ad): (220, "UncompiledDataWithoutPreparseDataWithJobMap"),
    ("read_only_space", 0x066d5): (218, "UncompiledDataWithPreparseDataAndJobMap"),
    ("read_only_space", 0x066fd): (251, "OnHeapBasicBlockProfilerDataMap"),
    ("read_only_space", 0x06725): (198, "TurbofanBitsetTypeMap"),
    ("read_only_space", 0x0674d): (202, "TurbofanUnionTypeMap"),
    ("read_only_space", 0x06775): (201, "TurbofanRangeTypeMap"),
    ("read_only_space", 0x0679d): (199, "TurbofanHeapConstantTypeMap"),
    ("read_only_space", 0x067c5): (200, "TurbofanOtherNumberConstantTypeMap"),
    ("read_only_space", 0x067ed): (247, "InternalClassMap"),
    ("read_only_space", 0x06815): (258, "SmiPairMap"),
    ("read_only_space", 0x0683d): (257, "SmiBoxMap"),
    ("read_only_space", 0x06865): (225, "ExportedSubClassBaseMap"),
    ("read_only_space", 0x0688d): (226, "ExportedSubClassMap"),
    ("read_only_space", 0x068b5): (231, "AbstractInternalClassSubclass1Map"),
    ("read_only_space", 0x068dd): (232, "AbstractInternalClassSubclass2Map"),
    ("read_only_space", 0x06905): (196, "InternalClassWithSmiElementsMap"),
    ("read_only_space", 0x0692d): (248, "InternalClassWithStructElementsMap"),
    ("read_only_space", 0x06955): (227, "ExportedSubClass2Map"),
    ("read_only_space", 0x0697d): (259, "SortStateMap"),
    ("read_only_space", 0x069a5): (146, "AllocationSiteWithWeakNextMap"),
    ("read_only_space", 0x069cd): (146, "AllocationSiteWithoutWeakNextMap"),
    ("read_only_space", 0x069f5): (137, "LoadHandler1Map"),
    ("read_only_space", 0x06a1d): (137, "LoadHandler2Map"),
    ("read_only_space", 0x06a45): (137, "LoadHandler3Map"),
    ("read_only_space", 0x06a6d): (138, "StoreHandler0Map"),
    ("read_only_space", 0x06a95): (138, "StoreHandler1Map"),
    ("read_only_space", 0x06abd): (138, "StoreHandler2Map"),
    ("read_only_space", 0x06ae5): (138, "StoreHandler3Map"),
    ("map_space", 0x02151): (2112, "ExternalMap"),
    ("map_space", 0x02179): (2116, "JSMessageObjectMap"),
}

# List of known V8 objects.
KNOWN_OBJECTS = {
  ("read_only_space", 0x021f1): "EmptyWeakArrayList",
  ("read_only_space", 0x021fd): "EmptyDescriptorArray",
  ("read_only_space", 0x02235): "EmptyEnumCache",
  ("read_only_space", 0x02269): "EmptyFixedArray",
  ("read_only_space", 0x02271): "NullValue",
  ("read_only_space", 0x02379): "UninitializedValue",
  ("read_only_space", 0x023f1): "UndefinedValue",
  ("read_only_space", 0x02435): "NanValue",
  ("read_only_space", 0x02469): "TheHoleValue",
  ("read_only_space", 0x02495): "HoleNanValue",
  ("read_only_space", 0x024c9): "TrueValue",
  ("read_only_space", 0x02509): "FalseValue",
  ("read_only_space", 0x02539): "empty_string",
  ("read_only_space", 0x02775): "EmptyScopeInfo",
  ("read_only_space", 0x027ad): "ArgumentsMarker",
  ("read_only_space", 0x0280d): "Exception",
  ("read_only_space", 0x02869): "TerminationException",
  ("read_only_space", 0x028d1): "OptimizedOut",
  ("read_only_space", 0x02931): "StaleRegister",
  ("read_only_space", 0x03431): "EmptyPropertyArray",
  ("read_only_space", 0x03439): "EmptyByteArray",
  ("read_only_space", 0x03441): "EmptyObjectBoilerplateDescription",
  ("read_only_space", 0x03475): "EmptyArrayBoilerplateDescription",
  ("read_only_space", 0x03481): "EmptyClosureFeedbackCellArray",
  ("read_only_space", 0x03489): "EmptySlowElementDictionary",
  ("read_only_space", 0x034ad): "EmptyOrderedHashMap",
  ("read_only_space", 0x034c1): "EmptyOrderedHashSet",
  ("read_only_space", 0x034d5): "EmptyFeedbackMetadata",
  ("read_only_space", 0x034e1): "EmptyPropertyDictionary",
  ("read_only_space", 0x03509): "EmptyOrderedPropertyDictionary",
  ("read_only_space", 0x03521): "EmptySwissPropertyDictionary",
  ("read_only_space", 0x03575): "NoOpInterceptorInfo",
  ("read_only_space", 0x0359d): "EmptyArrayList",
  ("read_only_space", 0x035a9): "EmptyWeakFixedArray",
  ("read_only_space", 0x035b1): "InfinityValue",
  ("read_only_space", 0x035bd): "MinusZeroValue",
  ("read_only_space", 0x035c9): "MinusInfinityValue",
  ("read_only_space", 0x035d5): "SelfReferenceMarker",
  ("read_only_space", 0x03615): "BasicBlockCountersMarker",
  ("read_only_space", 0x03659): "OffHeapTrampolineRelocationInfo",
  ("read_only_space", 0x03665): "GlobalThisBindingScopeInfo",
  ("read_only_space", 0x03695): "EmptyFunctionScopeInfo",
  ("read_only_space", 0x036b9): "NativeScopeInfo",
  ("read_only_space", 0x036d1): "HashSeed",
  ("old_space", 0x0421d): "ArgumentsIteratorAccessor",
  ("old_space", 0x04261): "ArrayLengthAccessor",
  ("old_space", 0x042a5): "BoundFunctionLengthAccessor",
  ("old_space", 0x042e9): "BoundFunctionNameAccessor",
  ("old_space", 0x0432d): "ErrorStackAccessor",
  ("old_space", 0x04371): "FunctionArgumentsAccessor",
  ("old_space", 0x043b5): "FunctionCallerAccessor",
  ("old_space", 0x043f9): "FunctionNameAccessor",
  ("old_space", 0x0443d): "FunctionLengthAccessor",
  ("old_space", 0x04481): "FunctionPrototypeAccessor",
  ("old_space", 0x044c5): "StringLengthAccessor",
  ("old_space", 0x04509): "InvalidPrototypeValidityCell",
  ("old_space", 0x04511): "EmptyScript",
  ("old_space", 0x04551): "ManyClosuresCell",
  ("old_space", 0x0455d): "ArrayConstructorProtector",
  ("old_space", 0x04571): "NoElementsProtector",
  ("old_space", 0x04585): "MegaDOMProtector",
  ("old_space", 0x04599): "IsConcatSpreadableProtector",
  ("old_space", 0x045ad): "ArraySpeciesProtector",
  ("old_space", 0x045c1): "TypedArraySpeciesProtector",
  ("old_space", 0x045d5): "PromiseSpeciesProtector",
  ("old_space", 0x045e9): "RegExpSpeciesProtector",
  ("old_space", 0x045fd): "StringLengthProtector",
  ("old_space", 0x04611): "ArrayIteratorProtector",
  ("old_space", 0x04625): "ArrayBufferDetachingProtector",
  ("old_space", 0x04639): "PromiseHookProtector",
  ("old_space", 0x0464d): "PromiseResolveProtector",
  ("old_space", 0x04661): "MapIteratorProtector",
  ("old_space", 0x04675): "PromiseThenProtector",
  ("old_space", 0x04689): "SetIteratorProtector",
  ("old_space", 0x0469d): "StringIteratorProtector",
  ("old_space", 0x046b1): "SingleCharacterStringCache",
  ("old_space", 0x04ab9): "StringSplitCache",
  ("old_space", 0x04ec1): "RegExpMultipleCache",
  ("old_space", 0x052c9): "BuiltinsConstantsTable",
  ("old_space", 0x056f5): "AsyncFunctionAwaitRejectSharedFun",
  ("old_space", 0x05719): "AsyncFunctionAwaitResolveSharedFun",
  ("old_space", 0x0573d): "AsyncGeneratorAwaitRejectSharedFun",
  ("old_space", 0x05761): "AsyncGeneratorAwaitResolveSharedFun",
  ("old_space", 0x05785): "AsyncGeneratorYieldResolveSharedFun",
  ("old_space", 0x057a9): "AsyncGeneratorReturnResolveSharedFun",
  ("old_space", 0x057cd): "AsyncGeneratorReturnClosedRejectSharedFun",
  ("old_space", 0x057f1): "AsyncGeneratorReturnClosedResolveSharedFun",
  ("old_space", 0x05815): "AsyncIteratorValueUnwrapSharedFun",
  ("old_space", 0x05839): "PromiseAllResolveElementSharedFun",
  ("old_space", 0x0585d): "PromiseAllSettledResolveElementSharedFun",
  ("old_space", 0x05881): "PromiseAllSettledRejectElementSharedFun",
  ("old_space", 0x058a5): "PromiseAnyRejectElementSharedFun",
  ("old_space", 0x058c9): "PromiseCapabilityDefaultRejectSharedFun",
  ("old_space", 0x058ed): "PromiseCapabilityDefaultResolveSharedFun",
  ("old_space", 0x05911): "PromiseCatchFinallySharedFun",
  ("old_space", 0x05935): "PromiseGetCapabilitiesExecutorSharedFun",
  ("old_space", 0x05959): "PromiseThenFinallySharedFun",
  ("old_space", 0x0597d): "PromiseThrowerFinallySharedFun",
  ("old_space", 0x059a1): "PromiseValueThunkFinallySharedFun",
  ("old_space", 0x059c5): "ProxyRevokeSharedFun",
}

# Lower 32 bits of first page addresses for various heap spaces.
HEAP_FIRST_PAGES = {
  0x000c0000: "old_space",
  0x00100000: "map_space",
  0x00000000: "read_only_space",
}

# List of known V8 Frame Markers.
FRAME_MARKERS = (
  "ENTRY",
  "CONSTRUCT_ENTRY",
  "EXIT",
  "WASM",
  "WASM_TO_JS",
  "JS_TO_WASM",
  "STACK_SWITCH",
  "WASM_DEBUG_BREAK",
  "C_WASM_ENTRY",
  "WASM_EXIT",
  "WASM_COMPILE_LAZY",
  "INTERPRETED",
  "BASELINE",
  "OPTIMIZED",
  "STUB",
  "BUILTIN_CONTINUATION",
  "JAVA_SCRIPT_BUILTIN_CONTINUATION",
  "JAVA_SCRIPT_BUILTIN_CONTINUATION_WITH_CATCH",
  "INTERNAL",
  "CONSTRUCT",
  "BUILTIN",
  "BUILTIN_EXIT",
  "NATIVE",
)

# This set of constants is generated from a shipping build.
